var __identifier_for_nowidget = "0000000000000F0000";    //適当。３秒くらいで更新が始まる値に調整してある。

var __const_cookie_save_count = 2;    //データ管理にクッキーを使用した時の保存上限数。データ・キーワードそれぞれ5個程度で限界？
var __const_gpkey_lock = "lock";
var __const_lpkey_strArrayCount = "sa_cnt";
var __const_lpkey_strArrayValue = "sa_val";


/*=============================================================================
ノードツリーの表示
=============================================================================*/
function _displayNodeTree(aNode, aNestLevel)
{
var str = "";
var i;

    if ( aNestLevel == null ) aNestLevel = 0;
    for ( i = 0 ; i < aNestLevel ; i++ ){
        str += "  ";
    }
    str += "<" + aNode.nodeName + "> " + aNode.nodeValue;
    alert(str);
    for ( i = 0 ; i < aNode.childNodes.length ; i++ ) {
        _displayNodeTree(aNode.childNodes.item(i), aNestLevel + 1);
    }
}

/*=============================================================================
日付の文字列化
=============================================================================*/
function _date2Text(aDate)
{
    if ( aDate == null ) aDate = new Date();
    var myYear    = aDate.getYear();
    var myYear4   = (myYear < 2000) ? myYear+1900 : myYear;
    var myMonth   = ("0"+(aDate.getMonth() + 1)).slice(-2);
    var myDate    = ("0"+aDate.getDate()).slice(-2);
    var myHours   = ("0"+aDate.getHours()).slice(-2);
    var myMinutes = ("0"+aDate.getMinutes()).slice(-2);
    return myYear4 + "/" + myMonth + "/" + myDate + "  " + myHours + ":" + myMinutes;
}

/*=============================================================================
elementの取得
=============================================================================*/
function _getElement(aId)
{
    return document.getElementById(aId);
}

/*=============================================================================
widget識別IDの取得

※widget環境ではwidget.identifierを、そうでなければ適当な文字列を返す。
=============================================================================*/
function _getWidgetId()
{
    if ( window.widget )
    {
		return widget.identifier;
    }
    else {
		return __identifier_for_nowidget;
    }
}


/*=============================================================================
XMLHttpRequestの生成

※WindowsのIE6でデバッグできるように。
=============================================================================*/
function _createXMLHttpRequest(){
    if( document.all ){
        return new ActiveXObject("Microsoft.XMLHTTP");
    }
    else if( document.implementation ){
        return new XMLHttpRequest();
    }
    else{
        return null;
    }
}

/*=============================================================================
cookieの読み書き

※デバッグでブラウザを使用できるようにするため、widgetのプリファレンス機能を
  cookieを使ってエミュレートするために使います。
=============================================================================*/
function _setCookieValue(aVal, aKey)
{
    if ( aVal ) {
		document.cookie = (aKey + "=" + escape(aVal));
    }
    else {
		document.cookie = (aKey + "=");
    }
}
function _getCookieValue(aKey)
{
    var pkey_array = document.cookie.split("; ");
    var i;
    var str = "";
    var srch = aKey+"=";
    for ( i = 0 ; i < pkey_array.length ; i++ )
    {
		var idx = pkey_array[i].indexOf(srch);
		if ( 0 == idx )
		{
			return unescape(pkey_array[i].substr(srch.length, pkey_array[i].length));
		}
    }
    return null;
}

/*=============================================================================
グローバルプリファレンス処理

※本widget全体で管理する値の読み書きを行います。
=============================================================================*/
function _getGlobalPkey(aKey)
{
    if ( window.widget ) return widget.preferenceForKey(aKey);
    else return _getPrefByCookie(aKey);
}
function _setGlobalPkey(aVal, aKey)
{
    if ( window.widget ) widget.setPreferenceForKey(aVal, aKey);
    else _setCookieValue(aVal, aKey);
}

/*=============================================================================
ローカルプリファレンス処理

※インスタンスごとに管理する値の読み書きを行います。
=============================================================================*/
function _getLocalPkey(aKey)
{
    if ( window.widget )
    {
		return widget.preferenceForKey(widget.identifier + "-" + aKey);
    }
    else {
		return _getCookieValue(__identifier_for_nowidget + "-" + aKey);
    }
}
function _setLocalPkey(aVal, aKey)
{
    if ( window.widget )
    {
		widget.setPreferenceForKey(aVal, widget.identifier + "-" + aKey);
    }
    else {
		_setCookieValue(aVal, __identifier_for_nowidget + "-" + aKey);
    }
}

/*=============================================================================
文字列配列データのクリア処理（プリファレンスを利用）
=============================================================================*/
function _clearStrArrayOfPref(aKey)
{
var i, cnt;
var key = __const_lpkey_strArrayCount + "-" + aKey;
    cnt = _getLocalPkey(key);
    if ( cnt == null ) return;
    
    for ( i = 0 ; i < cnt ; i++ )
    {
		_setLocalPkey(null, __const_lpkey_strArrayValue + "-" + aKey + "-" + i);
    }
    _setLocalPkey(null, key);
}

/*=============================================================================
文字列配列データの保存処理（プリファレンスを利用）
=============================================================================*/
function _saveStrArrayToPref(aStrArry, aKey)
{
var i, save_count;

    //現在のデータを消去
    _clearStrArrayOfPref(aKey);
    
    //保存上限の設定
    //※デバッグで使うブラウザのcookieサイズ制限を考慮して上限を設ける。
    if ( window.widget ) save_count = aStrArry.length;
    else if ( aStrArry.length > __const_cookie_save_count ) save_count = __const_cookie_save_count;
    else save_count = aStrArry.length;
    
    //保存
    for ( i = 0 ; i < save_count ; i++ )
    {
		_setLocalPkey(aStrArry[i], __const_lpkey_strArrayValue + "-" + aKey + "-" + i);
    }
    _setLocalPkey(save_count, __const_lpkey_strArrayCount + "-" + aKey);
}

/*=============================================================================
文字列配列データの読み出し処理（プリファレンスを利用）
=============================================================================*/
function _loadStrArrayFromPref(aKey)
{
var i, cnt;
    cnt = _getLocalPkey(__const_lpkey_strArrayCount + "-" + aKey);
    if ( cnt == null ) return null;
    
    var str_array = new Array();
    for ( i = 0 ; i < cnt ; i++ )
    {
		str_array[i] = _getLocalPkey(__const_lpkey_strArrayValue + "-" + aKey + "-" + i);
    }
    return str_array;
}


/*=============================================================================
X日後の日付文字列(yyyy-mm-dd形式）を取得

概要
    現在日付に＋Ｘ日をして得られた日付を文字列にして返す。
引数
    aXdays    : 現在日付に加算する日数
戻値
    現在日付に加算した日付の文字列(yyyy-mm-dd形式）
=============================================================================*/
function _getXdaysAfterStr(aXdays)
{
    var dt = new Date();
    dt.setTime(dt.getTime() + (aXdays*24*60*60*1000));
    var dt_y = new String(dt.getFullYear());
    var dt_m = new String(dt.getMonth()+1);
    if ( dt_m.length == 1 ) dt_m = "0" + dt_m;
    var dt_d = new String(dt.getDate());
    if ( dt_d.length == 1 ) dt_d = "0" + dt_d;
    return (dt_y + "-" + dt_m + "-" + dt_d);
}


/*=============================================================================
指定文字列内に、キーワード群のいずれかが存在するかをチェック

概要
    指定した文字列内に、キーワード群のうち当てはまるものがあるかをチェック。
引数
    aSourceStr    : チェック対象文字列
    aWordsStr    : キーワード群文字列（キーワード間は、スペースまたはカンマで区切り）
戻値
    当てはまるものがあれば true、なければ false
=============================================================================*/
function _checkIncludeWords(aSourceStr, aWordsStr)
{
var i;

    //チェック
    if ( null == aSourceStr || "" == aSourceStr ) return false;
    if ( null == aWordsStr || "" == aWordsStr ) return false;

    //チェック語の区切り文字を半角カンマへ変換（全角空白、全角カンマ、半角空白を対象）
    aWordsStr = aWordsStr.replace(/，/g,",");
    aWordsStr = aWordsStr.replace(/　/g,",");
    aWordsStr = aWordsStr.replace(/ /g,",");
    //カンマで分割
    var word_array = aWordsStr.split(",");
    //チェック
    for ( i = 0 ; i < word_array.length ; i++ )
    {
		if ( -1 != aSourceStr.indexOf( word_array[i] ) ) return true;
    }
    return false;
}


/*=============================================================================
配列のマージ（重複排除付き、nullは排除して処理）

概要
    重複データを排除して、配列をマージする。
引数
    aBaseArray    : 基準配列
    aNewArray    : マージする配列
戻値
    マージされた配列
=============================================================================*/
function _margeDistinctArray(aBaseArray, aNewArray)
{
var i, j;

    //追加データがなければ、追加せずに終了
    if ( null == aNewArray ) return aBaseArray;
    
    //追加データのマージ処理
    for ( i = 0 ; i < aNewArray.length ; i++ )
    {
		if ( ! aNewArray[i] ) continue;
		//重複データの探索
		var found = false;
		for ( j = 0 ; j < aBaseArray.length ; j++ )
		{
			if ( ! aBaseArray[j] ) continue;
			if ( aBaseArray[j] == aNewArray[i] )
			{
				found = true;
				break;
			}
		}
		//重複なしの場合にマージ処理を実行
		if ( ! found )    aBaseArray[aBaseArray.length] = aNewArray[i];
    }
    //マージした配列を返す
    return aBaseArray;
}


/*=============================================================================
排他ロック処理：_lock()の呼び出しで排他開始、_unlock()の呼び出しで排他解除
=============================================================================*/
//処理用変数
var __v_lock_successFunc;
var __v_lock_failFunc;
//排他開始関数
function _lock(aSuccessFunc, aFailFunc)
{
    //排他設定処理後に実行する関数の保存
    __v_lock_successFunc = aSuccessFunc;
    __v_lock_failFunc = aFailFunc;
    
    setTimeout("_sub_lock_term();", 500);
}
//排他開始関数：後処理
function _sub_lock_term()
{
    setTimeout("__v_lock_successFunc();", 5);
}
//排他解除関数
function _unlock() {
// ** document.getElementById("statusArea").innerText = "unlock";
    _setGlobalPkey(null, __const_gpkey_lock);
}
//排他解除関数
function _unlockForRemove() {
    var check_id = _getGlobalPkey(__const_gpkey_lock);
    if ( check_id != _getWidgetId() ) return;
    else _setGlobalPkey(null, __const_gpkey_lock);
}
